/* <![CDATA[ */
	var smart = {
		settings : {
			pathSmart : './',
			pathImages : '../../images/',
			pathInstaller : 'smart_installer',
			pathResponser : 'smart_response',
			activeClass : 'smart_active',
			verifyFixWarn: '{fix:warning}',
			verifyFixMess: '{fix:message}',
			abortAction: false
		}
	};
	jQuery(document).ready(function() {
		if (!jQuery('#Errors').hasClass('smart_nohide')) {
			jQuery('#Errors').hide();
		}
	});
	function hideErrors() {
		$('#Errors').hide(400);
	}
	function ResetWaiters() {
		$('img.smart_waiter').each(function(){
			$(this).fadeOut(400);
		});
		return true;
	}
	function RemoveClasses() {
		$('li.clickable').each(function(){
			if ($(this).hasClass(smart.settings.activeClass)) {
				$(this).removeClass(smart.settings.activeClass);
			}
		});
		return true;
	}
	function AbortActionSet() {
		smart.settings.abortAction = true;
		return true;
	}
	function VerifyFixForm(inputform) {
		if (!smart.settings.abortAction) {
			if ($(inputform.addon_id).val()==0) {
				alert(smart.settings.verifyFixWarn);
				return false;
			}
			return confirm(smart.settings.verifyFixMess);
		}
	}
	var sliding = true;
	$('ul.smart_list').children('li').click(function(){
		state = $(this).children('ul').css('display');
		if (state=='none') {
			$(this).children('ul').slideToggle(400, function(){
				$(this).children('ul').fadeTo(400, 1.0).css({'display':'block'});
			});
			$(this).children('img').attr('src', smart.settings.pathImages+'minus.gif');
		} else {
			if (sliding) {
				$(this).children('ul').slideToggle(400, function(){
					$(this).children('ul').fadeTo(400, 0.01).css({'display':'none'});
				});
				$(this).children('img').attr('src', smart.settings.pathImages+'plus.gif');
			} else {
				sliding = true;
			}
		}
	});
	$('#SlideUp').click(function(){
		$('ul.smart_list').children('li').children('ul').each(function(){
			$(this).slideUp(400);
			$(this).parent('li').children('img').attr('src', smart.settings.pathImages+'plus.gif');
		});
	});
	$('#SlideDown').click(function(){
		$('ul.smart_list').children('li').children('ul').each(function(){
			$(this).slideDown(400);
			$(this).parent('li').children('img').attr('src', smart.settings.pathImages+'minus.gif');
		});
	});
	$('#SlideToggle').click(function(){
		$('ul.smart_list').children('li').click();
	});
	$('li.clickable').click(function(){
		sliding = false;
		addon_id = $(this).attr('id');
		if (ResetWaiters()) { $('#Waiter_'+addon_id).fadeIn(300); }
		if (RemoveClasses()) { $(this).addClass(smart.settings.activeClass); }
		$.ajax({
			type: 'GET',
			url: smart.settings.pathSmart+smart.settings.pathResponser+'.php?addon_id='+addon_id,
			success: function(response) {
				data = response.split('||');
				if (data['0']==0) {
					$('#Title').text(data['2']);
					$('#Info').html(data['3']);
					$('#Author').text(data['6']);
					$('#Pubdate').text(data['7']);
					$('#Compatible').text(data['8']);
					$('#Size').text(data['9']);
					$('#Type').text(data['10']);
					$('#Addon').text(data['12']);
					if (data['11']!='') {
						$('#Preview').fadeOut(300, function(){
							$('#Loader').fadeIn('300');
							$('#Preview').attr('src', data['11']).load(function(){
								$('#Loader').fadeOut(300, function(){
									$('#Preview').fadeIn(400);
								});
							});
						});
					}
					$('#Install').fadeIn(300);
					$('#Waiter_'+addon_id).fadeOut(300);
				} else {
					$('#Errors').html(data['1']).show(400);
					window.setTimeout('hideErrors();', 5000);
				}
			}
		});
	});
	$('#Install').click(function(){
		addon_id = $('#Addon').text();
		$('#InstallLoader').fadeIn(300);
		$.ajax({
			type: 'GET',
			url: smart.settings.pathSmart+smart.settings.pathInstaller+'.php?addon_id='+addon_id,
			success: function(response) {
				data = response.split('||');
				$('#Errors').html(data['1']).show(400);
				window.setTimeout('hideErrors();', 5000);
				$('#InstallLoader').fadeOut(300);
				if (data['0']==0) {
					$('#Install').hide(200);
					$('#'+addon_id).fadeOut(400);
					$('#'+addon_id).parent('ul').click();
				}
			}
		});
	});
/* ]]>*/