<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: smart_manager.php
| Author: FILON (FDTD Designer)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";

if (!checkrights("SSM") || !defined("iAUTH") || !isset($_GET['aid']) || $_GET['aid'] != iAUTH) { redirect(BASEDIR); }

require_once THEMES."templates/admin_header.php";
require_once INFUSIONS."smart_system/infusion_db.php";
require_once INFUSIONS."smart_system/smart_functions.php";

if (isset($_GET['smart'])) {
	if ($_GET['smart'] == "update") {
		CheckInstalledAddons();
		if (UpdateSmartStore()) {
			redirect(FUSION_SELF.$aidlink."&status=su");
		} else {
			redirect(FUSION_SELF.$aidlink."&status=se");
		}
	} elseif ($_GET['smart'] == "ownership") {
		if (isset($_POST['fix'])) {
			$addon_id = (isset($_POST['addon_id']) && isnum($_POST['addon_id']) ? $_POST['addon_id'] : "0");
			if (FixOwnership($addon_id)) {
				redirect(FUSION_SELF.$aidlink."&status=of");
			} else {
				redirect(FUSION_SELF.$aidlink."&status=oe");
			}
		} elseif (isset($_POST['cancel'])) {
			redirect(FUSION_SELF.$aidlink);
		} else {
			CheckInstalledAddons();
			$result = dbquery("SELECT * FROM ".DB_SMART_ADDONS."");
			$op_list = "<option value='0'>".$locale['smart_049']."</option>\n";
			while ($data = dbarray($result)) {
				$addon_name = preg_replace("#(.+?)/index.php#i", "\\1", $data['addon_path'], 1);
				$path_parts = explode("/", $addon_name);
				$addon_name = str_replace("_", " ", end($path_parts));
				$op_list .= "<option value='".$data['addon_id']."'>".ucwords($addon_name)."</option>\n";
			}
			opentable($locale['smart_050']);
			echo "<div style='text-align:center;'>\n<form name='fixownership' method='post' action='".FUSION_SELF.$aidlink."&amp;smart=ownership' onsubmit='return VerifyFixForm(this);'>\n";
			echo "<select name='addon_id' class='textbox' style='width:250px'>\n".$op_list."</select>\n";
			echo "<input type='submit' name='fix' value='".$locale['smart_051']."' class='button' />\n";
			echo "<input type='submit' name='cancel' value='".$locale['smart_052']."' onclick='return AbortActionSet();' class='button' />\n";
			echo "</form>\n</div>\n";
			closeside();
		}
	}
}

add_to_title($locale['smart_004'].$locale['smart_005']);
add_to_head("<link rel='stylesheet' type='text/css' href='".SMART_STYLES."interface.css' media='all' />");
add_to_footer("<script type='text/javascript' src='".SMART_JS."core.js'></script>");
add_to_footer("<script type='text/javascript'>
	smart.settings.pathSmart = '".MY_SMART."';
	smart.settings.pathImages = '".IMAGES."';
	smart.settings.verifyFixWarn = '".$locale['smart_053']."';
	smart.settings.verifyFixMess = '".$locale['smart_054']."';
</script>");

if (isset($_GET['status'])) {
	if ($_GET['status'] == "su") {
		$message = $locale['smart_006'];
	} elseif ($_GET['status'] == "se") {
		$message = $locale['smart_007'];
	} elseif ($_GET['status'] == "of") {
		$message = $locale['smart_055'];
	} elseif ($_GET['status'] == "oe") {
		$message = $locale['smart_056'];
	} else {
		$message = $locale['smart_057'];
	}
	$s_error = true;
} else {
	$message = $locale['smart_008'];
	$s_error = false;
}

echo "<div class='admin-message".($s_error ? " smart_nohide" : "")."' id='Errors'>".$message."</div>\n";
echo "<div class='smart_autoload'>\n";
echo "<img src='".SMART_ICONS."spinner.gif' alt='' />\n";
echo "<img src='".SMART_ICONS."loader.gif' alt='' />\n";
echo "<img src='".SMART_ICONS."horizontal.gif' alt='' />\n";
echo "</div>\n";
opentable($locale['smart_009']);
$data = GetDataFromStorage();
echo "<div class='center smart_manager' id='SmartManager'>\n";
echo "<div class='smart_box_r'><strong>".$locale['smart_010']."</strong></div>\n";
echo "<div class='smart_box_l'><strong>".$locale['smart_011']."</strong></div>\n";
echo "<div class='smart_list_column'>\n<div class='smart_list_box' id='SmartListBox'>\n";
echo "<ul class='smart_list'>\n";
echo "<li class='tbl-border tbl2' unselectable='unselectable'><img src='".IMAGES."plus.gif' style='border:none;vertical-align:middle;' />".$locale['smart_012']." (".$data['lines']['1'].")\n";
echo "<ul id='Themes'>".PrintDataMerge($data['1'], $data['lines']['1'], $locale['smart_015'])."</ul>\n</li>\n";
echo "<li class='tbl-border tbl2' unselectable='unselectable'><img src='".IMAGES."plus.gif' style='border:none;vertical-align:middle;' />".$locale['smart_013']." (".$data['lines']['2'].")\n";
echo "<ul id='Panels'>".PrintDataMerge($data['2'], $data['lines']['2'], $locale['smart_016'])."</ul>\n</li>\n";
echo "<li class='tbl-border tbl2' unselectable='unselectable'><img src='".IMAGES."plus.gif' style='border:none;vertical-align:middle;' />".$locale['smart_014']." (".$data['lines']['3'].")\n";
echo "<ul id='Infusions'>".PrintDataMerge($data['3'], $data['lines']['3'], $locale['smart_017'])."</ul>\n</li>\n";
echo "</ul>\n</div>\n";
echo "<div class='smart_list_controls'><div class='smart_install_button'><img src='".SMART_ICONS."loader.gif' id='InstallLoader' style='display:none;border:none;vertical-align:middle;' alt='".$locale['smart_018']."' title='".$locale['smart_018']."' /> \n";
echo "<input type='button' value='".$locale['smart_019']."' class='button' id='Install' style='display:none;' /></div>\n";
echo "<a href='javascript:void(0);' id='SlideDown'><img src='".SMART_ICONS."slide_down.png' style='border:none;vertical-align:middle;' alt='".$locale['smart_020']."' title='".$locale['smart_020']."' /></a>&nbsp;";
echo "<a href='javascript:void(0);' id='SlideUp'><img src='".SMART_ICONS."slide_up.png' style='border:none;vertical-align:middle;' alt='".$locale['smart_021']."' title='".$locale['smart_021']."' /></a>&nbsp;";
echo "<a href='javascript:void(0);' id='SlideToggle'><img src='".SMART_ICONS."slide_toggle.png' style='border:none;vertical-align:middle;' alt='".$locale['smart_022']."' title='".$locale['smart_022']."' /></a>";
echo "</div>\n</div>\n";
echo "<div class='smart_explorer' id='SmartExplorer'>\n";
echo "<div class='smart_preview'>\n";
echo "<img src='".SMART_ICONS."spinner.gif' class='smart_loader' id='Loader' alt='".$locale['smart_023']."' title='".$locale['smart_023']."' />\n";
echo "<img src='".SMART_ICONS."smart_logo.png' class='smart_preview' id='Preview' alt='".$locale['smart_024']."' title='".$locale['smart_024']."' />\n";
echo "</div>";
echo "<div class='smart_info'><strong>".$locale['smart_025']."</strong><br />\n";
echo "<div class='smart_info_r'>\n";
echo $locale['smart_026']."<span id='Compatible'>7.xx</span><br />";
echo $locale['smart_027']."<span id='Size'>".$locale['smart_032']."</span><br />";
echo $locale['smart_028']."<span id='Type'>".$locale['smart_033']."</span>";
echo "</div>\n<div class='smart_info_l'>";
echo $locale['smart_029']."<span id='Title'>".$locale['smart_033']."</span><br />";
echo $locale['smart_030']."<span id='Author'>".$locale['smart_033']."</span><br />";
echo $locale['smart_031']."<span id='Pubdate'>00-00-0000</span>";
echo "<span id='Addon' style='display:none;'></span>";
echo "</div>\n</div>\n";
echo "<div class='smart_description'><strong>".$locale['smart_034']."</strong><br /><span id='Info'>".$locale['smart_035']."</span></div>";
echo "<div class='smart_stats'><strong>".$locale['smart_036']."</strong><br />\n";
echo $locale['smart_037'].dbcount("(addon_id)", DB_SMART_ADDONS)."<br />";
echo $locale['smart_038'].CountDataMerge($data)."<br />";
echo $locale['smart_039'].$data['storage']."<br />";
echo $locale['smart_040'].showdate("forumdate", filemtime(SMART_BASES."addons.xml"))."<br />";
echo "<a href='".FUSION_SELF.$aidlink."&smart=update' class='smart_update_link'><img src='".SMART_ICONS."update.png' style='border:none;vertical-align:middle;' alt='".$locale['smart_041']."' title='".$locale['smart_041']."' /> ".$locale['smart_041']."</a><br />";
echo "<a href='".FUSION_SELF.$aidlink."&smart=ownership' class='smart_ownership_link'><img src='".SMART_ICONS."ownership.png' style='border:none;vertical-align:middle;' alt='".$locale['smart_050']."' title='".$locale['smart_050']."' /> ".$locale['smart_050']."</a>";
echo "</div>\n</div>\n</div>\n";
closetable();

require_once THEMES."templates/footer.php";
?>